
%%%%%%%-half_power_bandwidth_technique_5th.m-%%%%%%%%%%
clc
clear
clf
format short g 
format compact
close all hidden 
warning off all
 
data0=load('N:\Shock and Vibration\tou\huatu\jienshi_dao\uncoated plate-sweep-550-500hz -1hz_s-5th-1g.txt','r+');  %See the data (uncoated plate-sweep- 550-500hz-1hz_s-5th-1g)
 
 
tic
fs=5120;      %-----sample frequecny
dt=1/fs;      %ʱ
[q,v] = size(data0) ;
%-------------ȷɨƵ----------
f_start=500  %%%%%%%%%%%%%%%%%%%% ɨƵʼƵ 
f_stop=550%%%%%%%%%%%%%%%%%%%%% ɨƵֹͣƵ 
 
%-------------ȻܵĲ-------------------
n=[0:1:q-1];
x=data0(:,2); % ɨƵʼƵ- 
x_abs=abs(x);
t=n/fs; %ʱ
figure(1) 
plot(t,x_abs);
xlabel('Time /sec','fontsize',14);
ylabel('Ampli /m/s','fontsize',14);
grid on
 
%-------------ɨƵֲ------------------
%---------------------
fen_number=floor(q/fs)
N=q-fs*(fen_number-4);   
%fen_number=20;
AA=zeros(2 ,fen_number)';
A = cell(1,fen_number);
tt=1;
for i=1:fen_number;
data=data0(fs*(i-1)+1:fs*i,:);
 x=data(:,2); % ɨƵʼƵ- 
 %x=data(:,6); % ɨƵʼƵ -ٶ
%-------------ֲʱ-------------------
t=dt*[0:1:fs-1]; %ʱ
figure(2)
subplot(8,fen_number/8,i);
plot(t,x);
xlabel('Time /sec','fontsize',3);
ylabel('Ampli /m/s','fontsize',3);
set(gca,'FontName','Times New Roman','FontSize',5)
grid on
 
 %-------------ֲFFT-----------
y=fft(x,N);    %źŽпFourier任
mag=abs(y);     %Fourier任
zhi{tt}=mag(1:N/2)*2/N;
freq{tt}=(fs/N)*(0:N/2-1);    %Ƶ
figure(3)
subplot(8,fen_number/8,i);
plot(freq{tt},zhi{tt}); %NyquistƵ֮ǰƵʱ仯
xlim([f_start f_stop]);%ȡ10-1000hzƵƵ
xlabel('Frequency /Hz','fontsize',3);
ylabel('Ampli /m/s','fontsize',3);
set(gca,'FontName','Times New Roman','FontSize',5)
grid on
 
tt=tt+1;
A(1,i)={zhi{i}'};
zz(i,:)=A{1,i};
xx=freq{1};
%ֲֵƵandͼǣҵֵӦƵ
[max_zz,pos_zz]=max(zz(i,:));
max_xx=xx(pos_zz);
AA(i ,2)=max_zz;
AA(i ,1)=max_xx;
hold on
str1 = num2str(max_zz);
str =str1(1:( length( num2str(floor(max_zz)))+1+1))  %%1ΪҪСλ%
str2 = num2str(max_xx);
str_hz =str2(1:( length( num2str(floor(max_xx)))+0+0))  %%1ΪҪСλ%
 
text(max_xx,max_zz,[str_hz,'  ',str],'Color','red','HorizontalAlignment','center','FontSize',7);
 
%ȥͼϲÿСֵ
p=find(xx<=f_start|xx>=f_stop);
zz(i,p)=NaN;
end
AA;
 
 %-------------ɾɨƵƵ
[bb,n] = size(AA);
B=[];
for i=1:bb,
   if  f_start<=AA(i,1)&& AA(i,1)<=f_stop; B(i,:)=AA(i,:);
   end
end
 
%[m,n]=find(B<=0.0001);
[m,n]=find(B< 0.0001);%%%%%%%%%˲ȥǲԵʵ
 B(m,:)=[]
 
 %%{
 %ȥBһͬԪأֵ
 BB(:,1)=unique(B(:,1));
 for iiii=1:size(BB,1)
     posi=find(B(:,1)==BB(iiii,1));
     BB(iiii,2)=max(B(posi,2));
 end
 %}
 B=BB;
 
%-------------ɨƵƵʶӦֵƵͼ----------
figure(5)
plot(B(:,1),B(:,2));
xlabel('Frequency /Hz','fontsize',14);
ylabel('Amplitude /m/s','fontsize',14);
grid on
%-------------ֵʹƽ----------
figure(6)
x1=B(:,1);
y1=B(:,2);
xx=x1(1):0.001:x1(end); 
yy=interp1(x1,y1,xx,'linear');
xxx=xx;
yyy1=yy;
n=length(yyy1);
a=yyy1;
for k=1:10
    b(1)=(3*a(1)+2*a(2)+a(3)-a(4))/5;
    b(2)=(4*a(1)+3*a(2)+2*a(3)+a(4))/10;
    for j=3:n-3
        b(j)=(a(j-2)+a(j-1)+a(j)+a(j+1)+a(j+2))/5;
    end
    b(n-1)=(a(n-3)+2*a(n-2)+3*a(n-1)+4*a(n))/10;
    b(n)=(-a(n-3)+a(n-2)+2*a(n-1)+3*a(n))/5;
    a=b;
end
yyy=a;
[xxx', yyy'];
 
 
%  find PEAKS ֵӦƵ
peak=max(yyy);
[value,pos_wn]=max(yyy);
wn=xxx(pos_wn)
str_peak= num2str(peak);
str_wn= num2str(wn);
str_peak1 =str_peak(1:( length( num2str(floor(peak)))+0+0));  %%1ΪҪСλ%
str_wn1 =str_wn(1:( length( num2str(floor(wn)))+0+0));  %%1ΪҪСλ%
hold on
 
%  find half_power points 빦ʵ㼰ӦƵ 
peak_ban=0.5*sqrt(2)* peak;      %%ͨȡ0.707
C_n_yyy_qian=abs(yyy(1:pos_wn)-peak_ban);
[value,pos]=sort(C_n_yyy_qian);
qian=pos(1);
w1=xxx(qian)
peak_ban_qian=yyy(qian);
 
C_n_yyy_hou=abs(yyy(pos_wn:end)-peak_ban);
[value,pos]=sort(C_n_yyy_hou);
hou=pos_wn+pos(1);
w2=xxx(hou)
peak_ban_hou=yyy(hou);
    
% IDENTIFY DAMPING AND NATURAL FREQUENCY
Q = wn/abs(w2 - w1);;
zuni= abs(w2 - w1)/(2*wn)
wz= wn/sqrt(1-2*zuni^2);
hold on
figure(6);
plot(xxx,yyy,'b-');hold on
plot([w1,w2],[peak_ban_qian,peak_ban_hou],'--sb',wn ,peak,'^r');
 
str_zuni= num2str(zuni);
str_zuni1 =str_zuni(1:( length( num2str(floor(zuni)))+5+1))  %%1ΪҪСλ%
grid on;
text(wn,peak,['    ',str_wn1,'  ',str_peak1,'    ', str_zuni1],'Color','red','HorizontalAlignment','left','FontSize',10);
toc

